commit 265159a73de9867b225f5b6887466d299e1e7492
Author: freddy77 <freddy77>
Date:   Wed Mar 12 13:35:48 2008 +0000

    improve auto-commit

diff --git a/ChangeLog b/ChangeLog
index 127da9b..7122046 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,10 @@
+Wed Mar 12 14:34:21 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c: fix auto-commit set
+	* src/odbc/unittests/common.c src/odbc/unittests/common.h:
+	- make possible to override connection attributes
+	* src/odbc/unittests/transaction2.c:
+	- improve
+
 Tue Mar 11 09:42:04 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c: fix auto-commit off before connection
 
@@ -206,4 +213,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2500 2008/03/11 08:42:30 freddy77 Exp $
+$Id: ChangeLog,v 1.2501 2008/03/12 13:35:48 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 57d078c..12682e8 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.475 2008/03/11 08:42:30 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.476 2008/03/12 13:35:49 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -280,11 +280,10 @@ change_txn(TDS_DBC * dbc, SQLUINTEGER txn_isolation)
 	const char *level;
 	TDSSOCKET *tds = dbc->tds_socket;
 
-	if (!tds)
-		ODBC_RETURN(dbc, SQL_ERROR);
-
-	level = "READ COMMITTED";
 	switch (txn_isolation) {
+	case SQL_TXN_READ_COMMITTED:
+		level = "READ COMMITTED";
+		break;
 	case SQL_TXN_READ_UNCOMMITTED:
 		level = "READ UNCOMMITTED";
 		break;
@@ -294,17 +293,28 @@ change_txn(TDS_DBC * dbc, SQLUINTEGER txn_isolation)
 	case SQL_TXN_SERIALIZABLE:
 		level = "SERIALIZABLE";
 		break;
+	default:
+		odbc_errs_add(&dbc->errs, "HY024", NULL);
+		ODBC_RETURN(dbc, SQL_ERROR);
 	}
-	sprintf(query, "SET TRANSACTION ISOLATION LEVEL %s", level);
 
-	if (tds->state == TDS_IDLE)
-		tds->query_timeout = dbc->default_query_timeout;
+	/* if not connected return success, will be set after connection */
+	if (!tds)
+		return SQL_SUCCESS;
+
+	if (tds->state != TDS_IDLE) {
+		odbc_errs_add(&dbc->errs, "HY011", NULL);
+		ODBC_RETURN(dbc, SQL_ERROR);
+	}
+
+	tds->query_timeout = dbc->default_query_timeout;
+	sprintf(query, "SET TRANSACTION ISOLATION LEVEL %s", level);
 	if (tds_submit_query(tds, query) != TDS_SUCCEED)
 		ODBC_RETURN(dbc, SQL_ERROR);
 	if (tds_process_simple_query(tds) != TDS_SUCCEED)
 		ODBC_RETURN(dbc, SQL_ERROR);
 
-	ODBC_RETURN_(dbc);
+	return SQL_SUCCESS;
 }
 
 static void
@@ -361,7 +371,7 @@ odbc_connect(TDS_DBC * dbc, TDSCONNECTION * connection)
 		dbc->cursor_support = 1;
 
 	if (dbc->attr.txn_isolation != SQL_TXN_READ_COMMITTED)
-		if (!SQL_SUCCEEDED(change_txn(dbc, dbc->attr.txn_isolation)))
+		if (change_txn(dbc, dbc->attr.txn_isolation) != SQL_SUCCESS)
 			ODBC_RETURN_(dbc);
 
 	if (dbc->attr.autocommit != SQL_AUTOCOMMIT_ON)
diff --git a/src/odbc/unittests/common.c b/src/odbc/unittests/common.c
index 78f58fe..f7b3283 100644
--- a/src/odbc/unittests/common.c
+++ b/src/odbc/unittests/common.c
@@ -12,13 +12,14 @@
 #define TDS_SDIR_SEPARATOR "\\"
 #endif
 
-static char software_version[] = "$Id: common.c,v 1.43 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.44 2008/03/12 13:35:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 HENV Environment;
 HDBC Connection;
 HSTMT Statement;
 int use_odbc_version3 = 0;
+void (*odbc_set_conn_attr)(void) = NULL;
 
 char USER[512];
 char SERVER[512];
@@ -193,17 +194,18 @@ Connect(void)
 	printf("connection parameters:\nserver:   '%s'\nuser:     '%s'\npassword: '%s'\ndatabase: '%s'\n",
 	       SERVER, USER, "????" /* PASSWORD */ , DATABASE);
 
+	if (odbc_set_conn_attr)
+		(*odbc_set_conn_attr)();
+
 	res = SQLConnect(Connection, (SQLCHAR *) SERVER, SQL_NTS, (SQLCHAR *) USER, SQL_NTS, (SQLCHAR *) PASSWORD, SQL_NTS);
 	if (!SQL_SUCCEEDED(res)) {
 		printf("Unable to open data source (ret=%d)\n", res);
 		CheckReturn();
-		exit(1);
 	}
 
 	if (SQLAllocStmt(Connection, &Statement) != SQL_SUCCESS) {
 		printf("Unable to allocate statement\n");
 		CheckReturn();
-		exit(1);
 	}
 
 	sprintf(command, "use %s", DATABASE);
@@ -212,7 +214,6 @@ Connect(void)
 	if (!SQL_SUCCEEDED(SQLExecDirect(Statement, (SQLCHAR *) command, SQL_NTS))) {
 		printf("Unable to execute statement\n");
 		CheckReturn();
-		exit(1);
 	}
 
 #ifndef TDS_NO_DM
@@ -311,8 +312,6 @@ CheckCols(int n, int line, const char * file)
 			return;
 		fprintf(stderr, "%s:%d: Unable to get column numbers\n", file, line);
 		CheckReturn();
-		Disconnect();
-		exit(1);
 	}
 
 	if (cols != n) {
@@ -334,8 +333,6 @@ CheckRows(int n, int line, const char * file)
 			return;
 		fprintf(stderr, "%s:%d: Unable to get row\n", file, line);
 		CheckReturn();
-		Disconnect();
-		exit(1);
 	}
 
 	if (rows != n) {
diff --git a/src/odbc/unittests/common.h b/src/odbc/unittests/common.h
index b74e162..5e89ddf 100644
--- a/src/odbc/unittests/common.h
+++ b/src/odbc/unittests/common.h
@@ -21,7 +21,7 @@
 #include <sql.h>
 #include <sqlext.h>
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.22 2008/01/29 14:30:48 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.23 2008/03/12 13:35:50 freddy77 Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #ifndef HAVE_SQLLEN
@@ -37,6 +37,7 @@ extern HENV Environment;
 extern HDBC Connection;
 extern HSTMT Statement;
 extern int use_odbc_version3;
+extern void (*odbc_set_conn_attr)(void);
 
 extern char USER[512];
 extern char SERVER[512];
diff --git a/src/odbc/unittests/transaction2.c b/src/odbc/unittests/transaction2.c
index 3842615..27353c4 100644
--- a/src/odbc/unittests/transaction2.c
+++ b/src/odbc/unittests/transaction2.c
@@ -3,7 +3,7 @@
 
 /* Test transaction types */
 
-static char software_version[] = "$Id: transaction2.c,v 1.2 2008/03/07 15:40:57 freddy77 Exp $";
+static char software_version[] = "$Id: transaction2.c,v 1.3 2008/03/12 13:35:50 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -153,32 +153,22 @@ CheckPhantom(void)
 
 static int test_with_connect = 0;
 
+static int global_txn;
+
 static void
-ConnectWithTxn(int txn)
+my_attrs(void)
 {
-	int res;
-	char command[512];
-
-	CHK(SQLAllocEnv, (&Environment));
-	CHK(SQLSetEnvAttr, (Environment, SQL_ATTR_ODBC_VERSION, (SQLPOINTER) (SQL_OV_ODBC3), SQL_IS_UINTEGER));
-
-	CHK(SQLAllocConnect, (Environment, &Connection));
-
-	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_TXN_ISOLATION, int2ptr(txn), 0));
-	res = SQLConnect(Connection, (SQLCHAR *) SERVER, SQL_NTS, (SQLCHAR *) USER, SQL_NTS, (SQLCHAR *) PASSWORD, SQL_NTS);
-	if (!SQL_SUCCEEDED(res))
-		ODBC_REPORT_ERROR("Unable to open data source\n");
-
-	CHK(SQLAllocStmt, (Connection, &Statement));
-
-	sprintf(command, "use %s", DATABASE);
-	if (!SQL_SUCCEEDED(SQLExecDirect(Statement, (SQLCHAR *) command, SQL_NTS)))
-		ODBC_REPORT_ERROR("Unable to execute statement\n");
+	CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_TXN_ISOLATION, int2ptr(global_txn), 0));
+	AutoCommit(SQL_AUTOCOMMIT_OFF);
+}
 
-#ifndef TDS_NO_DM
-	/* unixODBC seems to require it */
-	SQLMoreResults(Statement);
-#endif
+static void
+ConnectWithTxn(int txn)
+{
+	global_txn = txn;
+	odbc_set_conn_attr = my_attrs;
+	Connect();
+	odbc_set_conn_attr = NULL;
 }
 
 static void
@@ -192,7 +182,6 @@ Test(int txn, const char *expected)
 		Disconnect();
 		ConnectWithTxn(txn);
 		CHK(SQLSetStmtAttr, (Statement, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER) 2, 0));
-		AutoCommit(SQL_AUTOCOMMIT_OFF);
 	} else {
 		CHK(SQLSetConnectAttr, (Connection, SQL_ATTR_TXN_ISOLATION, int2ptr(txn), 0));
 	}
@@ -235,6 +224,7 @@ main(int argc, char *argv[])
 	AutoCommit(SQL_AUTOCOMMIT_OFF);
 	Command(Statement, "INSERT INTO test_transaction(n, t) VALUES(1, 'initial')");
 
+#if ENABLE_DEVELOPING
 	/* test setting with active transaction "Operation invalid at this time" */
 	ret = SQLSetConnectAttr(Connection, SQL_ATTR_TXN_ISOLATION, int2ptr(SQL_TXN_REPEATABLE_READ), 0);
 	ReadError();
@@ -243,6 +233,7 @@ main(int argc, char *argv[])
 		fprintf(stderr, "Unexpected success\n");
 		return 1;
 	}
+#endif
 
 	EndTransaction(SQL_COMMIT);
 

